/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_TEST_AUDIO_Controller_PROXY_BASE_HPP_
#define V2_TEST_AUDIO_Controller_PROXY_BASE_HPP_

#include <v2/Test/Audio/Controller.hpp>



#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/ByteBuffer.hpp>
#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <cstdint>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Attribute.hpp>
#include <CommonAPI/Event.hpp>
#include <CommonAPI/Proxy.hpp>
#include <functional>
#include <future>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v2 {
namespace Test {
namespace Audio {

class ControllerProxyBase
    : virtual public CommonAPI::Proxy {
public:
    typedef CommonAPI::ObservableAttribute<::v2::Test::Audio::Controller::KeyValueString> IVIDeviceInfoAttribute;
    typedef CommonAPI::ObservableReadonlyAttribute<std::vector< std::string >> AudioSourceTypesAttribute;
    typedef CommonAPI::ObservableReadonlyAttribute<::v2::Test::Audio::Controller::VolumeInfo> VolumeInfoAttribute;
    typedef CommonAPI::ObservableReadonlyAttribute<::v2::Test::Audio::Controller::KeyValueByteBuffer> KeyValueByteBufferMapAttribute;
    typedef CommonAPI::ObservableReadonlyAttribute<::v2::Test::Audio::Controller::DeviceStateMap> DeviceStateMapAttribute;
    typedef CommonAPI::ObservableReadonlyAttribute<::v2::Test::Audio::Controller::StringToShortMap> StringToShortMapAttribute;
    typedef CommonAPI::Event<
        std::vector< ::v2::Test::Audio::Controller::FocusStatus >
    > FocusStatusChangedEvent;

    typedef std::function<void(const CommonAPI::CallStatus&, const Controller::FocusControlError&, const Controller::AudioFocusResultType&)> ObtainFocusAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const Controller::FocusControlError&)> ReleaseFocusAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const Controller::VolumeControlError&)> SetVolumeAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const Controller::VolumeControlError&)> SetSourceVolumeAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const Controller::ErrorType&, const Controller::AudioSourceStatusInfo&)> GetAudioSourceStatusAsyncCallback;

    /*
     * description: 
     * test-purposed attribute which is read-write and map data type
     */
    virtual IVIDeviceInfoAttribute& getIVIDeviceInfoAttribute() = 0;
    /*
     * description: 
     * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
     * The list has the following format and is a string with upcase letters.
     * -"YOUTUBE_STREAMING"
     * -"TVING_STREAMING"
     * -"WATCHAR_STREAMING"
     */
    virtual AudioSourceTypesAttribute& getAudioSourceTypesAttribute() = 0;
    /*
     * description: 
     * Contains the Volume Information include min and max levels.
     * The range of these variables depends on each platform specification.
     * -Volume range is defined by audio specification.
     * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
     * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
     * -Mute notify the current mute status. (true : Mute / false : Unmute)
     */
    virtual VolumeInfoAttribute& getVolumeInfoAttribute() = 0;
    virtual KeyValueByteBufferMapAttribute& getKeyValueByteBufferMapAttribute() = 0;
    virtual DeviceStateMapAttribute& getDeviceStateMapAttribute() = 0;
    virtual StringToShortMapAttribute& getStringToShortMapAttribute() = 0;
    /*
     * description: 
     * The ccRC system requests to obtain audio focus.
     */
    virtual void ObtainFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, Controller::AudioFocusResultType &_res, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> ObtainFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ObtainFocusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    /*
     * description: 
     * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
     */
    virtual void ReleaseFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> ReleaseFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ReleaseFocusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    /*
     * description: 
     * Set the volume for outside the system.
     */
    virtual void SetVolume(uint8_t _volume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> SetVolumeAsync(const uint8_t &_volume, SetVolumeAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    /*
     * description: 
     * request to set source volume.
     * There are two member field in the Input parameter.
     * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
     * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
     * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
     * 
     * - maxVolume : it defines volume limitation which is described from the requirement
     * - VolumeControlError : please see "setVolume" for more detail explanation
     */
    virtual void SetSourceVolume(std::string _audioSourceType, uint16_t _volume, uint32_t _maxVolume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> SetSourceVolumeAsync(const std::string &_audioSourceType, const uint16_t &_volume, const uint32_t &_maxVolume, SetSourceVolumeAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    /*
     * description: 
     * Get FocusStatus and VolumeInfo for audio source type
     */
    virtual void GetAudioSourceStatus(std::string _audioSourceType, CommonAPI::CallStatus &_internalCallStatus, Controller::ErrorType &_error, Controller::AudioSourceStatusInfo &_audioSourceStatusInfo, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> GetAudioSourceStatusAsync(const std::string &_audioSourceType, GetAudioSourceStatusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    /*
     * description: 
     * broadcast when audio source type changed
     */
    virtual FocusStatusChangedEvent& getFocusStatusChangedEvent() = 0;

    virtual std::future<void> getCompletionFuture() = 0;
};

} // namespace Audio
} // namespace Test
} // namespace v2


// Compatibility
namespace v2_0 = v2;

#endif // V2_TEST_AUDIO_Controller_PROXY_BASE_HPP_
